#include <stdio.h>
#include <ctype.h>
#include <malloc.h>
#include <string.h>
#include <stdlib.h>
#include <sys/time.h>

char buf[1024];

void process(FILE *out, char **words)
{
    int f;
    
    f = 1;
    do
    {
	if(!f)
	    fputc(9, out);
	f = 0;
	fputs(*words, out);
	fputc(10, out);
    } while(*(++words) != NULL);
}

void txtparse(FILE *in, FILE *out)
{
    int state, c, w;
    char *p, *words[32];
    
    state = 0;
    p = buf;
    w = 0;
    while(!feof(in))
    {
	switch(state)
	{
	case 0:
	    do
	    {
		if(c == 10)
		{
		    words[w] = NULL;
		    process(out, words);
		    while(w > 0)
			free(words[--w]);
		}
	    } while(isspace(c = fgetc(in)));
	    state = 1;
	    break;
	case 1:
	    state = 0;
	    do
	    {
		if(c == '\"')
		{
		    state = 2;
		    break;
		}
		if(c == '\\')
		    c = fgetc(in);
		*(p++) = c;
	    } while(!isspace(c = fgetc(in)));
	    if(state == 0)
	    {
		*p = 0;
		words[w++] = strdup(buf);
		p = buf;
	    }
	    break;
	case 2:
	    while((c = fgetc(in)) != '\"')
	    {
		if(c == '\\')
		    c = fgetc(in);
		*(p++) = c;
	    }
	    if(isspace(c = fgetc(in)))
	    {
		state = 0;
		*p = 0;
		words[w++] = strdup(buf);
		p = buf;
	    } else {
		state = 1;
	    }
	    break;
	}
    }
}

void binparse(FILE *in, FILE *out)
{
    int i;
    int wc, cc;
    char *words[32];
    
    while(!feof(in))
    {
	if(fread(&wc, 4, 1, in))
	{
	    for(i = 0; i < wc; i++)
	    {
		fread(&cc, 4, 1, in);
		fread(buf, 1, cc, in);
		buf[cc] = 0;
		words[i] = strdup(buf);
	    }
	    words[i] = NULL;
	    process(out, words);
	    for(i = 0; i < wc; i++)
		free(words[i]);
	}
    }
}

int main(int argc, char **argv)
{
    FILE *stream, *out;
    struct timeval tv, tv2;
    double txtsec, binsec;
    
    if((stream = fopen("txtcmds", "r")) == NULL)
    {
	perror("txtcmds");
	exit(1);
    }
    if((out = fopen("txtout", "w")) == NULL)
    {
	perror("txtout");
	exit(1);
    }
    gettimeofday(&tv, NULL);
    txtparse(stream, out);
    gettimeofday(&tv2, NULL);
    txtsec = ((double)tv2.tv_sec + ((double)tv2.tv_usec / 1000000)) - ((double)tv.tv_sec + ((double)tv.tv_usec / 1000000));
    fclose(stream);
    fclose(out);
    if((stream = fopen("bincmds", "r")) == NULL)
    {
	perror("bincmds");
	exit(1);
    }
    if((out = fopen("binout", "w")) == NULL)
    {
	perror("binout");
	exit(1);
    }
    gettimeofday(&tv, NULL);
    binparse(stream, out);
    gettimeofday(&tv2, NULL);
    binsec = ((double)tv2.tv_sec + ((double)tv2.tv_usec / 1000000)) - ((double)tv.tv_sec + ((double)tv.tv_usec / 1000000));
    printf("Text parsing:   %f s\nBinary parsing: %f s\nDifference: %f%%\n", txtsec, binsec, ((txtsec - binsec) / binsec) * 100);
    fclose(stream);
    fclose(out);
    return(0);
}
